diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index 16c7d2869..6a9ce7265 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -13,6 +13,9 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.ChunkTilePos;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
@@ -27,74 +30,76 @@ public class Chunk
     public static final int CHUNK_SECTIONS = 16;
     public static boolean isLit;
     public boolean isLoaded;
-    public World world;
-    public short[] heightMap;
-    public int lowestY;
-    public final int xPosition;
-    public final int zPosition;
+    public final @NotNull World world;
+    public short @NotNull [] heightMap = new short[CHUNK_SIZE_X * CHUNK_SIZE_Z];
+    public final @NotNull ChunkPos pos;
     public long ticksOnUnload = -1;
-    public Map<ChunkPosition, TileEntity> tileEntityMap;
-    public double[] temperature;
-    public double[] humidity;
-    public double[] variety;
-    public @NotNull Int2ObjectMap<NextTickListEntry> tickList;
+    public final @NotNull Map<@NotNull ChunkTilePos, @NotNull TileEntity> tileEntityMap = new HashMap<>();
+    public double @NotNull [] temperature = new double[CHUNK_SIZE_X * CHUNK_SIZE_Z];
+    public double @NotNull [] humidity = new double[CHUNK_SIZE_X * CHUNK_SIZE_Z];
+    public double @NotNull [] variety = new double[CHUNK_SIZE_X * CHUNK_SIZE_Z];
+    public @NotNull Int2ObjectMap<NextTickListEntry> tickList = new Int2ObjectArrayMap<>();
     public int averageBlockHeight;
-    public boolean isTerrainPopulated;
-    public boolean isModified;
+    public boolean isTerrainPopulated = false;
+    public boolean isModified = false;
     public boolean neverSave;
-    public boolean hasEntities;
-    public long lastSaveTime;
-    protected final ChunkSection[] sections = new ChunkSection[CHUNK_SECTIONS];
+    public boolean hasEntities = false;
+    public long lastSaveTime = 0L;
+    protected final @NotNull ChunkSection @NotNull [] sections = new ChunkSection[CHUNK_SECTIONS];
 
-    public Chunk(World world, int x, int z)
-    {
-        tileEntityMap = new HashMap<>();
-        isTerrainPopulated = false;
-        isModified = false;
-        hasEntities = false;
-        lastSaveTime = 0L;
+    public Chunk(final @NotNull World world, final @NotNull ChunkPos pos) {
         this.world = world;
-        xPosition = x;
-        zPosition = z;
-        heightMap = new short[CHUNK_SIZE_X * CHUNK_SIZE_Z];
-        temperature = new double[CHUNK_SIZE_X * CHUNK_SIZE_Z];
-        humidity = new double[CHUNK_SIZE_X * CHUNK_SIZE_Z];
-        variety = new double[CHUNK_SIZE_X * CHUNK_SIZE_Z];
-        tickList = new Int2ObjectArrayMap<>();
+        this.pos = pos;
 
-        for (int i = 0; i < sections.length; i++) {
-            sections[i] = new ChunkSection(this, i);
+        for (int i = 0; i < this.sections.length; i++) {
+            this.sections[i] = new ChunkSection(this, i);
         }
     }
 
-    public static int makeBlockIndex(int x, int y, int z) {
+    @Deprecated
+    public Chunk(final @NotNull World world, final int x, final int z) {
+        this(world, new ChunkPos(x, z));
+    }
+
+    public static int makeBlockIndex(final @NotNull ChunkTilePos chunkTilePos) {
+        return (chunkTilePos.y * CHUNK_SIZE_Z * CHUNK_SIZE_X) + (chunkTilePos.z * CHUNK_SIZE_X) + chunkTilePos.x;
+    }
+
+    @Deprecated
+    public static int makeBlockIndex(final int x, final int y, final int z) {
         return (y * CHUNK_SIZE_Z * CHUNK_SIZE_X) + (z * CHUNK_SIZE_X) + x;
     }
 
-    public ChunkSection getSection(int index) {
+    public @Nullable ChunkSection getSection(final int index) {
         if (index < 0 || index >= CHUNK_SECTIONS) return null;
-        return sections[index];
+        return this.sections[index];
+    }
+
+    public @Nullable ChunkSection getSection(final @NotNull ChunkTilePos chunkTilePos) {
+        return this.getSection(chunkTilePos.getSectionIndex());
     }
 
     public void init() {
-        Arrays.fill(temperature, Double.NEGATIVE_INFINITY);
-        Arrays.fill(humidity, Double.NEGATIVE_INFINITY);
-        Arrays.fill(variety, Double.NEGATIVE_INFINITY);
+        Arrays.fill(this.temperature, Double.NEGATIVE_INFINITY);
+        Arrays.fill(this.humidity, Double.NEGATIVE_INFINITY);
+        Arrays.fill(this.variety, Double.NEGATIVE_INFINITY);
     }
 
-    public boolean isAtLocation(int x, int z)
-    {
-        return x == xPosition && z == zPosition;
+    public boolean isAtLocation(final @NotNull ChunkPos chunkPos) {
+        return this.pos.equals(chunkPos);
     }
 
-    public int getHeightValue(int x, int z)
-    {
-        return heightMap[z * CHUNK_SIZE_X + x];
+    @Deprecated
+    public final boolean isAtLocation(final int x, final int z) {
+        return x == this.pos.x && z == this.pos.z;
     }
 
-    private void setHeightValue(int x, int z, int y)
-    {
-        heightMap[z * CHUNK_SIZE_X + x] = (short) y;
+    public int getHeightValue(final int x, final int z) {
+        return this.heightMap[z * CHUNK_SIZE_X + x];
+    }
+
+    private void setHeightValue(int x, int z, int y) {
+        this.heightMap[z * CHUNK_SIZE_X + x] = (short) y;
     }
 
     public void addTick(final @NotNull NextTickListEntry entry) {
@@ -110,10 +115,8 @@ public class Chunk
         this.tickList.remove(pos);
     }
 
-    public void recalcHeightmapOnly()
-    {
+    public void recalcHeightmapOnly() {
         int acc = 0;
-        int lowestY = CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y - 1;
         for(int x = 0; x < CHUNK_SIZE_X; x++)
         {
             for(int z = 0; z < CHUNK_SIZE_Z; z++)
@@ -124,14 +127,9 @@ public class Chunk
                 }
                 setHeightValue(x, z, y);
                 acc += y;
-                if(y < lowestY)
-                {
-                    lowestY = y;
-                }
             }
         }
 
-        this.lowestY = lowestY;
         isModified = true;
         averageBlockHeight = acc / (CHUNK_SIZE_X * CHUNK_SIZE_Z);
     }
@@ -167,327 +165,388 @@ public class Chunk
         isModified = true;
     }
 
-    private void lightGaps(int x, int z)
-    {
+    private void lightGaps(int x, int z) {
         int y = getHeightValue(x, z);
-        int worldX = xPosition * CHUNK_SIZE_X + x;
-        int worldZ = zPosition * CHUNK_SIZE_Z + z;
+        int worldX = this.pos.x * CHUNK_SIZE_X + x;
+        int worldZ = this.pos.z * CHUNK_SIZE_Z + z;
         lightGap(worldX - 1, worldZ, y);
         lightGap(worldX + 1, worldZ, y);
         lightGap(worldX, worldZ - 1, y);
         lightGap(worldX, worldZ + 1, y);
     }
 
-    private void lightGap(int x, int z, int heightValue)
+    private void lightGap(int x, int z, int y)
     {
         int blockHeight = world.getHeightValue(x, z);
-        if(blockHeight > heightValue)
+        if(blockHeight > y)
         {
-            world.scheduleLightingUpdate(LightLayer.Sky, x, heightValue, z, x, blockHeight, z);
+            world.scheduleLightingUpdate(LightLayer.Sky, x, y, z, x, blockHeight, z);
             isModified = true;
         }
-        else if(blockHeight < heightValue)
+        else if(blockHeight < y)
         {
-            world.scheduleLightingUpdate(LightLayer.Sky, x, blockHeight, z, x, heightValue, z);
+            world.scheduleLightingUpdate(LightLayer.Sky, x, blockHeight, z, x, y, z);
             isModified = true;
         }
     }
 
-    private void recalcHeight(int x, int y, int z)
-    {
-        int heightValue = getHeightValue(x, z);
-        int iy = heightValue;
-        if(y > heightValue)
-        {
-            iy = y;
+    private void recalcHeight(final @NotNull ChunkTilePos tilePos) {
+        final int heightValue = this.getHeightValue(tilePos.x, tilePos.z);
+        final @NotNull ChunkTilePos iPos = new ChunkTilePos(tilePos.x, heightValue, tilePos.z);
+        if(tilePos.y > heightValue) {
+            iPos.y = tilePos.y;
         }
-        for(; iy > 0 && Blocks.lightBlock[getBlockID(x, iy - 1, z) & 0x3fff] == 0; iy--) { }
-        if(iy == heightValue)
-        {
+        for (; iPos.y > 0 && Blocks.lightBlock[this.getBlockId(iPos.down()) & 0x3fff] == 0; iPos.y--) { }
+
+        if (iPos.y == heightValue) {
             return;
         }
-        world.markBlocksDirtyVertical(x, z, iy, heightValue);
-        setHeightValue(x, z, iy);
-        if(iy < lowestY)
-        {
-            lowestY = iy;
-        }
-        else
-        {
-            int lowestY = (CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y) - 1;
-            for(int ix = 0; ix < CHUNK_SIZE_X; ix++)
-            {
-                for(int iz = 0; iz < CHUNK_SIZE_Z; iz++)
-                {
-                    int iHeightValue = getHeightValue(x, z);
-                    if(iHeightValue < lowestY)
-                    {
-                        lowestY = iHeightValue;
-                    }
-                }
 
-            }
+        this.world.markBlocksDirtyVertical(iPos.x, iPos.z, iPos.y, heightValue);
+        this.setHeightValue(iPos.x, iPos.z, iPos.y);
 
-            this.lowestY = lowestY;
-        }
-        int worldX = xPosition * CHUNK_SIZE_X + x;
-        int worldZ = zPosition * CHUNK_SIZE_Z + z;
-        if(iy < heightValue)
-        {
-            for(int dy = iy; dy < heightValue; dy++)
-            {
-                setBrightness(LightLayer.Sky, x, dy, z, 15);
+        final @NotNull TilePos worldPos = new TilePos(this.pos, tilePos);
+        if(iPos.y < heightValue) {
+            for (int dy = iPos.y; dy < heightValue; dy++) {
+                this.setBrightness(LightLayer.Sky, iPos.x, dy, iPos.z, World.MAX_BRIGHTNESS);
             }
-        }
-        else
-        {
-            world.scheduleLightingUpdate(LightLayer.Sky, worldX, heightValue, worldZ, worldX, iy, worldZ);
-            for(int dy = heightValue; dy < iy; dy++)
-            {
-                setBrightness(LightLayer.Sky, x, dy, z, 0);
+        } else {
+            this.world.scheduleLightingUpdate(LightLayer.Sky, new TilePos(worldPos.x, heightValue, worldPos.z), new TilePos(worldPos.x, iPos.y, worldPos.z));
+            for (int dy = heightValue; dy < iPos.y; dy++) {
+                setBrightness(LightLayer.Sky, iPos.x, dy, iPos.z, 0);
             }
         }
-        int lightValue = 15;
-        int lightY = iy;
-        while(iy > 0 && lightValue > 0)
-        {
-            iy--;
-            int lightBlock = Blocks.lightBlock[getBlockID(x, iy, z)];
-            if(lightBlock == 0)
-            {
+
+        int lightValue = World.MAX_BRIGHTNESS;
+        final int lightY = iPos.y;
+        while (iPos.y > 0 && lightValue > 0) {
+            iPos.y--;
+            int lightBlock = Blocks.lightBlock[this.getBlockId(iPos)];
+            if(lightBlock == 0) {
                 lightBlock = 1;
             }
             lightValue -= lightBlock;
-            if(lightValue < 0)
-            {
+            if(lightValue < 0) {
                 lightValue = 0;
             }
-            setBrightness(LightLayer.Sky, x, iy, z, lightValue);
+            this.setBrightness(LightLayer.Sky, iPos, lightValue);
         }
-        for(; iy > 0 && Blocks.lightBlock[getBlockID(x, iy - 1, z)] == 0; iy--) { }
-        if(iy != lightY)
-        {
-            world.scheduleLightingUpdate(LightLayer.Sky, worldX - 1, iy, worldZ - 1, worldX + 1, lightY, worldZ + 1);
+
+        for(; iPos.y > 0 && Blocks.lightBlock[this.getBlockId(iPos.down())] == 0; iPos.y--) { }
+
+        if(iPos.y != lightY) {
+            this.world.scheduleLightingUpdate(LightLayer.Sky, new TilePos(worldPos.x - 1, iPos.y, worldPos.z - 1), new TilePos(worldPos.x + 1, lightY, worldPos.z + 1));
         }
-        isModified = true;
 
+        this.isModified = true;
     }
 
-    public int getBlockID(int x, int y, int z)
-    {
-        if (x < 0 || x >= CHUNK_SIZE_X || y < 0 || y >= CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y || z < 0 || z >= CHUNK_SIZE_Z) return 0;
-        return getSection(y / ChunkSection.SECTION_SIZE_Y).getBlock(x, y % ChunkSection.SECTION_SIZE_Y, z);
+    public int getBlockId(final @NotNull ChunkTilePos tilePos) {
+        if (!tilePos.inBounds()) {
+            return 0;
+        }
+
+        return Objects.requireNonNull(this.getSection(tilePos)).getBlockId(tilePos.toChunkSectionTilePos());
+    }
+
+    @Deprecated
+    public final int getBlockID(final int x, final int y, final int z) {
+        return this.getBlockId(new ChunkTilePos(x, y, z));
+    }
+
+    public @Nullable Block<?> getBlock(final @NotNull ChunkTilePos tilePos) {
+        return Blocks.getBlock(this.getBlockId(tilePos));
+    }
+
+    public boolean setBlockIdDataRaw(final @NotNull ChunkTilePos tilePos, final int id, final int data) {
+        return this.setBlockIdData(tilePos, id, data, true);
+    }
+
+    public boolean setBlockIdData(final @NotNull ChunkTilePos tilePos, final int id, final int data) {
+        return this.setBlockIdData(tilePos, id, data, false);
     }
 
     // will not trigger onBlockRemoved or onBlockPlacedByWorld
-    public boolean setBlockIDWithMetadataRaw(int x, int y, int z, int id, int data)
-    {
-        if (x < 0 || x >= CHUNK_SIZE_X || y < 0 || y >= CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y || z < 0 || z >= CHUNK_SIZE_Z) return false;
+    @Deprecated
+    public final boolean setBlockIDWithMetadataRaw(final int x, final int y, final int z, final int id, final int data) {
+        return this.setBlockIdDataRaw(new ChunkTilePos(x, y, z), id, data);
+    }
+
+    private boolean setBlockIdData(final @NotNull ChunkTilePos tilePos, final int id, final int data, final boolean raw) {
+        if (!tilePos.inBounds()) {
+            return false;
+        }
+
+        final @NotNull ChunkSection section = Objects.requireNonNull(this.getSection(tilePos));
+        final int heightValue = this.getHeightValue(tilePos.x, tilePos.z);
 
-        ChunkSection section = getSection(y / ChunkSection.SECTION_SIZE_Y);
-        int heightValue = getHeightValue(x, z);
+        final int currentId = section.getBlockId(tilePos.toChunkSectionTilePos());
+        final int currentData = section.getData(tilePos.toChunkSectionTilePos());
 
-        int currentId = section.getBlock(x, y % ChunkSection.SECTION_SIZE_Y, z);
-        int currentData = section.getData(x, y % ChunkSection.SECTION_SIZE_Y, z);
+        final @Nullable Block<?> currentBlock = Blocks.getBlock(currentId);
+        final @Nullable Block<?> newBlock = Blocks.getBlock(id);
 
-        if(currentId == id && currentData == data) {
+        if (currentId == id && currentData == data) {
             return false;
         }
 
-        section.setBlock(x, y % ChunkSection.SECTION_SIZE_Y, z, id);
-        section.setData(x, y % ChunkSection.SECTION_SIZE_Y, z, data);
+        section.setBlockId(tilePos.toChunkSectionTilePos(), id);
+        section.setData(tilePos.toChunkSectionTilePos(), id);
 
-        int worldX = xPosition * CHUNK_SIZE_X + x;
-        int worldZ = zPosition * CHUNK_SIZE_Z + z;
+        final @NotNull TilePos worldPos = new TilePos(this.pos, tilePos);
+        if (!raw && currentBlock != null && !this.world.isClientSide) {
+            currentBlock.onBlockRemoved(this.world, worldPos.x, worldPos.y, worldPos.z, currentData);
+        }
 
-        if(!world.worldType.hasCeiling())
-        {
-            if(Blocks.lightBlock[id & 0x3fff] != 0) {
-                if(y >= heightValue) {
-                    recalcHeight(x, y + 1, z);
+        if (!this.world.getWorldType().hasCeiling()) {
+            if (Blocks.lightBlock[id & 0x3FFF] != 0) {
+                if (tilePos.y >= heightValue) {
+                    this.recalcHeight(tilePos.up());
                 }
+            } else if (tilePos.y == heightValue - 1) {
+                this.recalcHeight(tilePos);
             }
-            else if(y == heightValue - 1) {
-                recalcHeight(x, y, z);
-            }
-            world.scheduleLightingUpdate(LightLayer.Sky, worldX, y, worldZ, worldX, y, worldZ);
+            this.world.scheduleLightingUpdate(LightLayer.Sky, worldPos);
         }
 
-        world.scheduleLightingUpdate(LightLayer.Block, worldX, y, worldZ, worldX, y, worldZ);
-        lightGaps(x, z);
+        this.world.scheduleLightingUpdate(LightLayer.Block, worldPos);
+        this.lightGaps(tilePos.x, tilePos.z);
 
-        isModified = true;
+        if (!raw && newBlock != null) {
+            newBlock.onBlockPlacedByWorld(this.world, worldPos.x, worldPos.y, worldPos.z);
+        }
+
+        this.isModified = true;
         return true;
     }
 
-    public boolean setBlockIDWithMetadata(int x, int y, int z, int id, int data)
-    {
-        if (x < 0 || x >= CHUNK_SIZE_X || y < 0 || y >= CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y || z < 0 || z >= CHUNK_SIZE_Z) return false;
+    @Deprecated
+    public final boolean setBlockIDWithMetadata(final int x, final int y, final int z, final int id, final int data) {
+        return this.setBlockIdData(new ChunkTilePos(x, y, z), id, data);
+    }
 
-        ChunkSection section = getSection(y / ChunkSection.SECTION_SIZE_Y);
-        int heightValue = getHeightValue(x, z);
+    public boolean setBlockId(final @NotNull ChunkTilePos tilePos, final int id) {
+        return this.setBlockIdData(tilePos, id, 0);
+    }
 
-        int currentId = section.getBlock(x, y % ChunkSection.SECTION_SIZE_Y, z);
-        int currentData = section.getData(x, y % ChunkSection.SECTION_SIZE_Y, z);
+    @Deprecated
+    public final boolean setBlockID(final int x, final int y, final int z, final int id) {
+        return this.setBlockId(new ChunkTilePos(x, y, z), id);
+    }
 
-        if(currentId == id && currentData == data) {
-            return false;
+    public int getBlockData(final @NotNull ChunkTilePos tilePos) {
+        if (!tilePos.inBounds()) {
+            return 0;
         }
 
-        section.setBlock(x, y % ChunkSection.SECTION_SIZE_Y, z, id);
-        section.setData(x, y % ChunkSection.SECTION_SIZE_Y, z, data);
+        return Objects.requireNonNull(this.getSection(tilePos)).getData(tilePos.toChunkSectionTilePos());
+    }
+
+    @Deprecated
+    public final int getBlockMetadata(final int x, final int y, final int z) {
+        return this.getBlockData(new ChunkTilePos(x, y, z));
+    }
 
-        int worldX = xPosition * CHUNK_SIZE_X + x;
-        int worldZ = zPosition * CHUNK_SIZE_Z + z;
-        if(currentId != 0 && !world.isClientSide)
-        {
-            Blocks.blocksList[currentId].onBlockRemoved(world, worldX, y, worldZ, currentData);
+    public boolean setBlockData(final @NotNull ChunkTilePos tilePos, final int value) {
+        if (!tilePos.inBounds()) {
+            return false;
         }
 
-        if(!world.worldType.hasCeiling())
-        {
-            if(Blocks.lightBlock[id & 0x3fff] != 0) {
-                if(y >= heightValue) {
-                    recalcHeight(x, y + 1, z);
-                }
-            }
-            else if(y == heightValue - 1) {
-                recalcHeight(x, y, z);
-            }
-            world.scheduleLightingUpdate(LightLayer.Sky, worldX, y, worldZ, worldX, y, worldZ);
+        Objects.requireNonNull(this.getSection(tilePos)).setData(tilePos.toChunkSectionTilePos(), value);
+        this.isModified = true;
+
+        return true;
+    }
+
+    @Deprecated
+    public final void setBlockMetadata(final int x, final int y, final int z, final int value) {
+        this.setBlockData(new ChunkTilePos(x, y, z), value);
+    }
+
+    public @Nullable Biome getBlockBiome(final @NotNull ChunkTilePos tilePos) {
+        if (!tilePos.inBounds()) {
+            return null;
         }
 
-        world.scheduleLightingUpdate(LightLayer.Block, worldX, y, worldZ, worldX, y, worldZ);
-        lightGaps(x, z);
+        return Objects.requireNonNull(this.getSection(tilePos)).getBiome(tilePos.toChunkSectionTilePos());
+    }
+
+    @Deprecated
+    public final @Nullable Biome getBlockBiome(final int x, final int y, final int z) {
+        return this.getBlockBiome(new ChunkTilePos(x, y, z));
+    }
 
-        if(Blocks.getBlock(id) != null) {
-            Blocks.blocksList[id].onBlockPlacedByWorld(world, worldX, y, worldZ);
+    public boolean setBlockBiome(final @NotNull ChunkTilePos tilePos, final @NotNull Biome biome) {
+        if (!tilePos.inBounds()) {
+            return false;
         }
 
-        isModified = true;
+        Objects.requireNonNull(this.getSection(tilePos)).setBiome(tilePos.toChunkSectionTilePos(), biome);
+        this.isModified = true;
+
         return true;
     }
 
-    public boolean setBlockID(int x, int y, int z, int id)
-    {
-        return setBlockIDWithMetadata(x, y, z, id, 0);
+    @Deprecated
+    public final boolean setBlockBiome(final int x, final int y, final int z, final @NotNull Biome biome) {
+        return this.setBlockBiome(new ChunkTilePos(x, y, z), biome);
     }
 
-    public int getBlockMetadata(int x, int y, int z)
-    {
-        if (x < 0 || x >= CHUNK_SIZE_X || y < 0 || y >= CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y || z < 0 || z >= CHUNK_SIZE_Z) return 0;
+    public double getBlockTemperature(final @NotNull ChunkTilePos tilePos) {
+        if (!tilePos.inBounds()) {
+            return Double.NEGATIVE_INFINITY;
+        }
 
-        return getSection(y / ChunkSection.SECTION_SIZE_Y).getData(x, y % ChunkSection.SECTION_SIZE_Y, z);
+        return this.temperature[tilePos.x * CHUNK_SIZE_Z + tilePos.z];
     }
 
-    public void setBlockMetadata(int x, int y, int z, int value)
-    {
-        if (x < 0 || x >= CHUNK_SIZE_X || y < 0 || y >= CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y || z < 0 || z >= CHUNK_SIZE_Z) return;
-
-        getSection(y / ChunkSection.SECTION_SIZE_Y).setData(x, y % ChunkSection.SECTION_SIZE_Y, z, value);
-        isModified = true;
+    @Deprecated
+    public final double getBlockTemperature(final int x, final int z) {
+        return this.getBlockTemperature(new ChunkTilePos(x, 0, z));
     }
-    
-    public @Nullable Biome getBlockBiome(int x, int y, int z)
-    {
-        if (x < 0 || x >= CHUNK_SIZE_X || y < 0 || y >= CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y || z < 0 || z >= CHUNK_SIZE_Z) return null;
 
-        return getSection(y / ChunkSection.SECTION_SIZE_Y).getBiome(x, y % ChunkSection.SECTION_SIZE_Y, z);
+    public void setBlockTemperature(final @NotNull ChunkTilePos tilePos, final double temperature) {
+        if (!tilePos.inBounds()) {
+            return;
+        }
+
+        this.temperature[tilePos.x * CHUNK_SIZE_Z + tilePos.z] = temperature;
+        this.isModified = true;
     }
-    
-    public boolean setBlockBiome(int x, int y, int z, Biome biome)
-    {
-        if (x < 0 || x >= CHUNK_SIZE_X || y < 0 || y >= CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y || z < 0 || z >= CHUNK_SIZE_Z) return false;
 
-        getSection(y / ChunkSection.SECTION_SIZE_Y).setBiome(x, y % ChunkSection.SECTION_SIZE_Y, z, biome);
-        isModified = true;
+    @Deprecated
+    public final boolean setBlockTemperature(final int x, final int z, final double temperature) {
+        if (temperature == this.temperature[x * CHUNK_SIZE_Z + z]) {
+            return false;
+        }
 
+        this.setBlockTemperature(new ChunkTilePos(x, 0, z), temperature);
         return true;
     }
-    
-    public double getBlockTemperature(int x, int z)
-    {
-        return temperature[x * CHUNK_SIZE_Z + z];
+
+    public double getBlockHumidity(final @NotNull ChunkTilePos tilePos) {
+        if (!tilePos.inBounds()) {
+            return Double.NEGATIVE_INFINITY;
+        }
+
+        return this.humidity[tilePos.x * CHUNK_SIZE_Z + tilePos.z];
     }
-    
-    public boolean setBlockTemperature(int x, int z, double temperature)
-    {
-        double presentTemperature = this.temperature[x * CHUNK_SIZE_Z + z];
-        if (presentTemperature == temperature) return false;
-        this.temperature[x * CHUNK_SIZE_Z + z] = temperature;
-        isModified = true;
-        return true;
+
+    @Deprecated
+    public final double getBlockHumidity(final int x, final int z) {
+        return this.getBlockHumidity(new ChunkTilePos(x, 0, z));
     }
-    
-    public double getBlockHumidity(int x, int z)
-    {
-        return humidity[x * CHUNK_SIZE_Z + z];
+
+    public void setBlockHumidity(final @NotNull ChunkTilePos tilePos, final double humidity) {
+        if (!tilePos.inBounds()) {
+            return;
+        }
+
+        this.humidity[tilePos.x * CHUNK_SIZE_Z + tilePos.z] = humidity;
+        this.isModified = true;
     }
-    
-    public boolean setBlockHumidity(int x, int z, double humidity)
-    {
-        double presentHumidity = this.humidity[x * CHUNK_SIZE_Z + z];
-        if (presentHumidity == humidity) return false;
-        this.humidity[x * CHUNK_SIZE_Z + z] = humidity;
-        isModified = true;
+
+    @Deprecated
+    public final boolean setBlockHumidity(final int x, final int z, final double humidity) {
+        if (humidity == this.humidity[x * CHUNK_SIZE_Z + z]) {
+            return false;
+        }
+
+        this.setBlockHumidity(new ChunkTilePos(x, 0, z), humidity);
         return true;
     }
-    public double getBlockVariety(int x, int z)
-    {
-        return variety[x * CHUNK_SIZE_Z + z];
+
+    public double getBlockVariety(final @NotNull ChunkTilePos tilePos) {
+        if (!tilePos.inBounds()) {
+            return Double.NEGATIVE_INFINITY;
+        }
+
+        return this.variety[tilePos.x * CHUNK_SIZE_Z + tilePos.z];
     }
-    public boolean setBlockVariety(int x, int z, double variety)
-    {
-        double presentVariety = this.variety[x * CHUNK_SIZE_Z + z];
-        if (presentVariety == variety) return false;
-        this.variety[x * CHUNK_SIZE_Z + z] = variety;
-        isModified = true;
+
+    @Deprecated
+    public final double getBlockVariety(final int x, final int z) {
+        return this.getBlockVariety(new ChunkTilePos(x, 0, z));
+    }
+
+    public void setBlockVariety(final @NotNull ChunkTilePos tilePos, final double variety) {
+        if (!tilePos.inBounds()) {
+            return;
+        }
+
+        this.variety[tilePos.x * CHUNK_SIZE_Z + tilePos.z] = variety;
+        this.isModified = true;
+    }
+
+    @Deprecated
+    public final boolean setBlockVariety(final int x, final int z, final double variety) {
+        if (variety == this.variety[x * CHUNK_SIZE_Z + z]) {
+            return false;
+        }
+
+        this.setBlockVariety(new ChunkTilePos(x, 0, z), variety);
         return true;
     }
 
-    public int getBrightness(LightLayer layer, int x, int y, int z)
-    {
-        if (x < 0 || x >= CHUNK_SIZE_X || y < 0 || y >= CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y || z < 0 || z >= CHUNK_SIZE_Z) return 0;
+    public int getBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePos tilePos) {
+        if (!tilePos.inBounds()) {
+            return 0;
+        }
 
-        return getSection(y / ChunkSection.SECTION_SIZE_Y).getBrightness(layer, x, y % ChunkSection.SECTION_SIZE_Y, z);
+        return Objects.requireNonNull(this.getSection(tilePos)).getBrightness(lightLayer, tilePos.toChunkSectionTilePos());
     }
 
-    public void setBrightness(LightLayer layer, int x, int y, int z, int value)
-    {
-        if (x < 0 || x >= CHUNK_SIZE_X || y < 0 || y >= CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y || z < 0 || z >= CHUNK_SIZE_Z) return;
+    @Deprecated
+    public final int getBrightness(final @NotNull LightLayer lightLayer, final int x, final int y, final int z) {
+        return this.getBrightness(lightLayer, new ChunkTilePos(x, y, z));
+    }
 
-        getSection(y / ChunkSection.SECTION_SIZE_Y).setBrightness(layer, x, y % ChunkSection.SECTION_SIZE_Y, z, value);
-        isModified = true;
+    public void setBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePos tilePos, final int value) {
+        if (!tilePos.inBounds()) {
+            return;
+        }
+
+        Objects.requireNonNull(this.getSection(tilePos)).setBrightness(lightLayer, tilePos.toChunkSectionTilePos(), value);
+        this.isModified = true;
     }
 
-    public int getRawBrightness(int x, int y, int z, int skySubtract)
-    {
-        if (x < 0 || x >= CHUNK_SIZE_X || y < 0 || y >= CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y || z < 0 || z >= CHUNK_SIZE_Z) return 0;
+    @Deprecated
+    public final void setBrightness(final @NotNull LightLayer lightLayer, final int x, final int y, final int z, final int value) {
+        this.setBrightness(lightLayer, new ChunkTilePos(x, y, z), value);
+    }
+
+    public int getRawBrightness(final @NotNull ChunkTilePos tilePos, final int subtractedSkyLight) {
+        if (!tilePos.inBounds()) {
+            return 0;
+        }
 
-        int lightValue = getSection(y / ChunkSection.SECTION_SIZE_Y).getRawBrightness(x, y % ChunkSection.SECTION_SIZE_Y, z, skySubtract);
+        final int lightValue = Objects.requireNonNull(this.getSection(tilePos)).getRawBrightness(tilePos.toChunkSectionTilePos(), subtractedSkyLight);
         if (lightValue > 0) {
-            isLit = true;
+            Chunk.isLit = true;
         }
 
         return lightValue;
     }
 
-    public void addEntity(Entity entity)
-    {
+    @Deprecated
+    public final int getRawBrightness(final int x, final int y, final int z, final int subtractedSkyLight) {
+        return this.getRawBrightness(new ChunkTilePos(x, y, z), subtractedSkyLight);
+    }
+
+    public void addEntity(final @NotNull Entity entity) {
         hasEntities = true;
         isModified = true;
-        int x = MathHelper.floor(entity.x / CHUNK_SIZE_X);
-        int z = MathHelper.floor(entity.z / CHUNK_SIZE_Z);
-        if(x != xPosition || z != zPosition)
+        final @NotNull ChunkPos entityChunkPos = new ChunkPos(entity);
+        if(!entityChunkPos.equals(this.pos))
         {
             LOGGER.warn("Wrong location! {}", entity);
             Thread.dumpStack();
         }
         int section = MathHelper.clamp(MathHelper.floor(entity.y / 16D), 0, CHUNK_SECTIONS - 1);
         entity.addedToChunk = true;
-        entity.chunkCoordX = xPosition;
+        entity.chunkCoordX = this.pos.x;
         entity.chunkCoordY = section;
-        entity.chunkCoordZ = zPosition;
+        entity.chunkCoordZ = this.pos.z;
         getSection(section).addEntity(entity);
     }
 
